/*
 * Enhydra Java Application Server
 * The Initial Developer of the Original Code is Lutris Technologies Inc.
 * Portions created by Lutris are Copyright (C) 1997-2000 Lutris Technologies
 * Inc.
 * All Rights Reserved.
 *
 * The contents of this file are subject to the Enhydra Public License Version
 * 1.0 (the "License"); you may not use this file except in compliance with the
 * License. You may obtain a copy of the License at
 * http://www.enhydra.org/software/license/epl.html
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
 * License for the specific language governing rights and limitations under the
 * License.
 *
 * $Id: Configure.java,v 1.2 2000/02/24 20:20:18 pmahar Exp $
 */

package org.enhydra.jbuilder.sample;

import javax.swing.*;
import javax.swing.filechooser.*;
import java.awt.*;
import java.awt.event.*;
import java.io.File;
import java.io.BufferedReader;
import java.io.FileReader;
import java.io.PrintWriter;
import java.io.FileWriter;

public class Configure extends JDialog {
  private JPanel panelMain = new JPanel();
  private BorderLayout layoutRoot = new BorderLayout();
  JPanel panelAction = new JPanel();
  JButton buttonConfigure = new JButton();
  JButton buttonCancel = new JButton();
  JPanel panelSpacer = new JPanel();
  JPanel panelSelect = new JPanel();
  GridBagLayout gridBagLayout1 = new GridBagLayout();
  JLabel labelSelect = new JLabel();
  JTextField textProject = new JTextField();
  JButton buttonSelect = new JButton();
  GridBagLayout gridBagLayout2 = new GridBagLayout();
  JTextField textPort = new JTextField();
  JLabel labelPort = new JLabel();

  public Configure() {
    try {
      jbInit();
      pmInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }

  public static void main(String[] args) {
    Configure conDialog = new Configure();
    conDialog.show();
  }

  private void jbInit() throws Exception {
    this.getContentPane().setLayout(layoutRoot);
    panelMain.setLayout(gridBagLayout2);
    buttonConfigure.setEnabled(false);
    buttonConfigure.setText("Configure");
    buttonConfigure.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent e) {
        buttonConfigure_actionPerformed(e);
      }
    });
    buttonCancel.setText("Cancel");
    buttonCancel.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent e) {
        buttonCancel_actionPerformed(e);
      }
    });
    panelSelect.setLayout(gridBagLayout1);
    labelSelect.setText("Select the EnhydraSample.jpr to configure:");
    textProject.setPreferredSize(new Dimension(250, 21));
    textProject.setText("jTextField1");
    buttonSelect.setText("Select...");
    buttonSelect.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent e) {
        buttonSelect_actionPerformed(e);
      }
    });
    textPort.setPreferredSize(new Dimension(50, 21));
    textPort.setText("80");
    textPort.setHorizontalAlignment(SwingConstants.RIGHT);
    labelPort.setText("MultiServer Port:");
    this.getContentPane().add(panelMain, BorderLayout.CENTER);
    panelMain.add(panelAction, new GridBagConstraints(0, 1, 1, 1, 0.4, 0.4
            ,GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(0, 0, 0, 0), 0, 0));
    panelAction.add(panelSpacer, null);
    panelAction.add(buttonConfigure, null);
    panelAction.add(buttonCancel, null);
    panelMain.add(panelSelect, new GridBagConstraints(0, 0, 1, 1, 0.6, 0.6
            ,GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(0, 0, 0, 0), 0, 0));
    panelSelect.add(textProject, new GridBagConstraints(0, 1, 2, 1, 0.8, 0.8
            ,GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(5, 5, 5, 5), 0, 0));
    panelSelect.add(buttonSelect, new GridBagConstraints(2, 1, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(5, 5, 5, 5), 0, 0));
    panelSelect.add(labelSelect, new GridBagConstraints(0, 0, 3, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(5, 5, 2, 5), 0, 0));
    panelSelect.add(textPort, new GridBagConstraints(1, 2, 1, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(5, 5, 10, 5), 0, 0));
    panelSelect.add(labelPort, new GridBagConstraints(0, 2, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(5, 5, 10, 5), 0, 0));
  }

  private void pmInit() {
    textProject.setText("");
    pack();
  }

  void buttonSelect_actionPerformed(ActionEvent e) {
    JFileChooser chooser = new JFileChooser();
    File selection = null;
    chooser.setFileFilter(new SampleFilter());
    if (chooser.showOpenDialog(new JFrame()) != JFileChooser.CANCEL_OPTION) {
      selection = chooser.getSelectedFile();
      if ((selection != null) && (! selection.isDirectory())) {
        textProject.setText(selection.getAbsolutePath());
        buttonConfigure.setEnabled(true);
      }
    }
  }

  void buttonCancel_actionPerformed(ActionEvent e) {
    closeDialog();
  }

  private void closeDialog() {
    this.setVisible(false);
    this.dispose();
    System.exit(0);
  }

  void buttonConfigure_actionPerformed(ActionEvent event) {
    File project = new File(textProject.getText());
    int port = 80;
    try {
      port = Integer.parseInt(textPort.getText());
    } catch (Exception e) {
      port = 80;
    }
    ConfigUtil util = new ConfigUtil(project, port);
    util.run();
    JOptionPane.showMessageDialog(null,
       "Kelp Sample Configuration Complete",
       "Kelp", JOptionPane.INFORMATION_MESSAGE);
    closeDialog();

  }
}



class SampleFilter extends FileFilter {
    /**
     * Creates an extension file filter without an extensions set.
     */
    public SampleFilter() {
    }

    /**
     * Return true if this file is EnhydraSample.jpr
     */
    public boolean accept(File f) {
      boolean acceptFile = false;
      if (f.isDirectory()) {
        acceptFile = true;
      } else {
        acceptFile = f.getAbsoluteFile().toString().trim().toLowerCase().endsWith("enhydrasample.jpr");
      }
      return acceptFile;
    }

    /**
     * Returns the human readable description of this filter.
     */
    public String getDescription() {
      return "JBuilder Kelp Sample (EnhydraSample.jpr)";
   }
}


class ConfigUtil {
  private File project;
  private int port = 80;

  public ConfigUtil(File jpr, int p) {
    project = jpr;
    port    = p;
  }

  protected void run() {
    modifyServerConf();
    modifySampleConf();
    modifyStartServer();
    modifySamplePage();
    modifySampleProject();
  }

 private void modifyServerConf() {
     String appRoot  = project.getParent();
     String filename = appRoot + File.separator
                     + "conf" + File.separator + "multiserver.conf";
     String[] find    = new String[4];
     String[] replace = new String[4];
     find[0]    = "Server.ConfDir";
     replace[0] = "Server.ConfDir = " + appRoot + File.separator + "conf";
     find[1]    = "Server.LogFile";
     replace[1] = "Server.LogFile = " + appRoot + File.separator + "log" +
                   File.separator + "multiserver.log" ;
     find[2]    = "Filter.StandardLogger.InitArgs.logFile";
     replace[2] = "Filter.StandardLogger.InitArgs.logFile = " +
                  appRoot + File.separator + "log" +
                  File.separator + "access.log";
     find[3]    = "Connection.HttpConnSample.Port";
     replace[3] = "Connection.HttpConnSample.Port = " + port;
     searchAndReplace(filename, find, replace);
  }

   private void modifySampleConf() {
     String appRoot    = project.getParent();
     String classRoot  = project.getParentFile().getParentFile().getParent();

     String filename = appRoot + File.separator
                     + "conf" + File.separator + "EnhydraSample.conf";
     String[] find    = new String[3];
     String[] replace = new String[3];
     find[0]    = "Server.ClassPath[]";
     replace[0] = "Server.ClassPath[] = " + classRoot + File.separator + "myclasses";
     find[1]    = "# AppRoot";
     replace[1] = "AppRoot = " + doubleEscape("\"" + appRoot + "\"");
     find[2]    = "Server.AutoReload";
     replace[2] = "# Server.AutoReload = \"true\"";
     searchAndReplace(filename, find, replace);
  }

   private void modifyStartServer() {
     String appRoot    = project.getParent();
     String filename = appRoot  + File.separator +
                     "org"      + File.separator +
                     "enhydra"  + File.separator +
                     "jbuilder" + File.separator +
                     "sample"   + File.separator +
                     "StartMultiServer.java";
     String[] find    = new String[1];
     String[] replace = new String[1];
     find[0]    = "args[0]";
     replace[0] = doubleEscape("args[0] = \"" + appRoot
                              + File.separator + "conf"
                              + File.separator + "multiserver.conf\";");
     searchAndReplace(filename, find, replace);
  }

  private void modifySamplePage() {
     String appRoot    = project.getParent();
     String docRoot    = project.getParentFile().getParent();
     String filename = appRoot  + File.separator +
                     "EnhydraSample.html";
     String[] find    = new String[1];
     String[] replace = new String[1];
     find[0]    = "<a href=file://../doc/developer/jb-kelp.html>";
     replace[0] = "<a href=file:" +
                 docRoot + File.separator +
                 "doc"   + File.separator +
                 "developer" + File.separator +
                 "jb-kelp.html>";
     searchAndReplace(filename, find, replace);
  }

   private void modifySampleProject() {
     String appRoot    = project.getParent();
     String filename = project.getAbsolutePath();
     String[] find    = new String[1];
     String[] replace = new String[1];
     find[0]    = "sys[0].enhydra.xmlc.map.package.fromFolder.0";
     replace[0] = "sys[0].enhydra.xmlc.map.package.fromFolder.0=" +
                 appRoot + File.separator +
                 "org"      + File.separator +
                 "enhydra"  + File.separator +
                 "jbuilder" + File.separator +
                 "sample"   + File.separator +
                 "html";
     project = null;
     searchAndReplace(filename, find, replace);
     project = new File(filename);
  }



  private void searchAndReplace(String filename,
                   String[] find,
                   String[] replace) {
    System.out.println("Updating: " + filename);
    BufferedReader  in = null;
    PrintWriter    out = null;
    File file = new File(filename);
    File temp = null;
    try {
      temp = File.createTempFile("kelp",".tmp", file.getParentFile());
      String tempName = temp.getAbsolutePath();
      temp.delete();
      temp = null;
      file.renameTo(new File(tempName));
      file = null;
      temp = new File(tempName);
      temp.deleteOnExit();
      in = new BufferedReader(new FileReader(temp));
      out = new PrintWriter(new FileWriter(new File(filename)));
      String line = in.readLine();
      while (line != null) {
        for (int i = 0 ; i < find.length; i++) {
          if (line.trim().startsWith(find[i])) {
            line = replace[i];
            break;
          }
        }
        out.println(line);
        line = in.readLine();
      }
      in.close();
      out.close();
    } catch (java.io.IOException e) {
      e.printStackTrace();
    }
    in   = null;
    out  = null;
    file = null;
    temp = null;
  }

 private String doubleEscape(String in) {
     String escaped = new String(in);
     String current = new String(in);
     StringBuffer doubled = new StringBuffer();

      int index = current.indexOf("\\");
      while (index > -1) {
        doubled.append(current.substring(0,index));
        doubled.append("\\\\");
        if (index == current.lastIndexOf("\\")) {
          if (! current.endsWith("\\")) {
            doubled.append(current.substring(index + 1));
          }
          current = "";
        } else {
          current = current.substring(index + 1);
        }
        index = current.indexOf("\\");
      }

      // if no "\" found, then return original string.
      if (doubled.toString().trim().length() > 0) {
        escaped = doubled.toString().trim();
      }
      return escaped;
    }

}